﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 * 
 * Author: Sabine Winkler
 */
#endregion

using HeuristicLab.Core;
using HeuristicLab.Data;
using HeuristicLab.Encodings.IntegerVectorEncoding;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;

namespace HeuristicLab.Problems.GrammaticalEvolution.Mappers {
  /// <summary>
  /// IGenotypeToPhenotypeMapper
  /// </summary>
  [HeuristicLab.Persistence.Default.CompositeSerializers.Storable.StorableType("9B8482E6-1B6D-4407-B1B9-A92D146B3A6E")]
  public interface IGenotypeToPhenotypeMapper : IIntegerVectorOperator {
    ISymbolicExpressionTree Map(IRandom random, IntMatrix bounds, int length,
                               ISymbolicExpressionGrammar grammar,
                               IntegerVector genotype);
  }
}
